'''
Created on Aug 22, 2014

@author: ajn
'''

import sys
import numpy.random
#import numpy.linalg
import math

def print_header():
    print "method:N:M:opt:cnt_sample:cnt_update:cnt_measure:cnt_pdfxn:cnt_pdfxnmax:cnt_propsmooth:cnt_pdfsmooth:cnt_eval_logp_x0:RMSEm:RMSEstd"

def print_stats(method, N, M, opt, rmsem, rmsestd, oc):
    # method: N: M: opt : cnt_sample: cnt_update: cnt_measure: cnt_pdfxn: cnt_pdfxnmax: cnt_propsmooth: RMSE
    if (method == 'mhips' or
        method == 'bp' or
        method == 'pgas'):
        tmp = opt['R']
    else:
        tmp = 0
    print "%s:%d:%d:%d:%d:%d:%d:%d:%d:%d:%d:%d:%.4f:%.4f" % (method, N, M, tmp,
                                        oc.cnt_sample, oc.cnt_update,
                                        oc.cnt_measure, oc.cnt_pdfxn,
                                        oc.cnt_pdfxnmax, oc.cnt_propsmooth,
                                        oc.cnt_pdfsmooth, oc.cnt_eval_logp_x0,
                                        rmsem, rmsestd)
    sys.stdout.flush()

def print_header2():
    print "method:N:M:opt:cnt_sample:cnt_update:cnt_measure:cnt_pdfxn:cnt_pdfxnmax:cnt_propsmooth:cnt_pdfsmooth:cnt_eval_logp_x0:RMSE1m:RMSE1std:RMSE2m:RMSE2std"


def print_stats2(method, N, M, opt, rmse1, rmse1std, rmse2, rmse2std, oc):
    # method: N: M: opt : cnt_sample: cnt_update: cnt_measure: cnt_pdfxn: cnt_pdfxnmax: cnt_propsmooth: RMSE
    if (method == 'mhips' or
        method == 'bp'):
        tmp = opt['R']
    else:
        tmp = 0
    print "%s:%d:%d:%d:%d:%d:%d:%d:%d:%d:%d:%d:%.4f:%.4f:%.4f:%.4f" % (method, N, M, tmp,
                                        oc.cnt_sample, oc.cnt_update,
                                        oc.cnt_measure, oc.cnt_pdfxn,
                                        oc.cnt_pdfxnmax, oc.cnt_propsmooth,
                                        oc.cnt_pdfsmooth, oc.cnt_eval_logp_x0,
                                        rmse1, rmse1std, rmse2, rmse2std)
    sys.stdout.flush()

#def calc_enees(xhat, xtrue):
#    T = xhat.shape[0]
#    N = xhat.shape[1]
#    D = xhat.shape[2]
#    xmean = numpy.mean(xhat, 1)
#    ENEESk = numpy.zeros((T,))
#    P = numpy.zeros((T, D, D))
#    for i in xrange(T):
#        for j in xrange(N):
#            tmp = (xhat[i, j, :] - xtrue[i]).reshape((-1, 1))
#            P[i] += tmp.dot(tmp.T)
#        P[i] /= N
#    for i in xrange(T):
#        tmp = xmean[i] - xtrue[i]
#        ENEESk[i] = tmp.T.dot(numpy.linalg.lstsq(P[i], tmp)[0])
#
#    return numpy.mean(ENEESk)

def parse_setup():
    no_more_data = False
    tests = list()
    while not no_more_data:
        line = sys.stdin.readline()
        sys.stdout.write(line)
        if line == '':
            no_more_data = True
        if line == '\n':
            continue
        words = line.split()

        if (words[0].lower() == 'full'):
            tests.append(('full', int(words[1]), int(words[2]), {}))
        elif (words[0].lower() == 'rs'):
            tests.append(('rs', int(words[1]), int(words[2]), {}))
        elif (words[0].lower() == 'rsas'):
            tests.append(('rsas', int(words[1]), int(words[2]), {}))
        elif (words[0].lower() == 'mhips'):
            tests.append(('mhips', int(words[1]), int(words[2]), {'R':int(words[3])}))
        elif (words[0].lower() == 'mhips_reduced'):
            tests.append(('mhips_reduced', int(words[1]), int(words[2]), {'R':int(words[3])}))
        elif (words[0].lower() == 'mcmc'):
            tests.append(('mcmc', int(words[1]), int(words[2]), {'R':int(words[3])}))
        elif (words[0].lower() == 'bp'):
            tests.append(('bp', int(words[1]), int(words[2]), {'R':int(words[3])}))
        elif (words[0].lower()[0] == '#'):
            pass
        elif (words[0].lower() == 'end'):
            break
        else:
            sys.exit('Unsupported algorithm')

    return tests

def generate_doubleint_data(T, Q, R, p0, v0):
    A = numpy.asarray(((1.0, 1.0), (0.0, 1.0)))
    x = numpy.zeros((2, T + 1))
    x[0, 0] = p0
    x[1, 0] = v0
    y = numpy.zeros((T + 1, 1))
    y[0] = x[0, 0] + numpy.random.normal(0.0, math.sqrt(R))
    for i in xrange(T):
        x[:, i + 1] = A.dot(x[:, i])
        x[1, i + 1] += numpy.random.normal(0.0, math.sqrt(Q))

        y[i + 1] = x[0, i + 1] + numpy.random.normal(0.0, math.sqrt(R))

    return (x.T, y)
