import numpy
import scipy.io
from common import generate_doubleint_data

if __name__ == '__main__':

    nbr = 5000

    Q = 1.0
    R = 1.0
    T = 50

    p0 = -10
    v0 = 1


    x = numpy.empty((nbr, T + 1, 2))
    y = numpy.empty((nbr, T + 1, 1))
    for k in xrange(nbr):
        numpy.random.seed(k)
        (xk, yk) = generate_doubleint_data(T, Q, R, p0, v0)
        x[k, :] = xk
        y[k, :] = yk

    data = scipy.io.savemat("doubleint_dataset.mat", {'x': x, 'y': y})



