'''
Created on Aug 21, 2014

@author: ajn
'''
import numpy
import math
from pyparticleest.simulator import Simulator
from pyparticleest.utils.intrument import Instrumenter as Instrumenter
from pscomp.models import MarginDoubleInt as DoubleInt
from pscomp.common import parse_setup
from pscomp.common import print_header
from pscomp.common import print_stats
from pscomp.common import generate_doubleint_data as generate_data
#import matplotlib.pyplot as plt


if __name__ == '__main__':

    iterations = 2000

    Q = 1.0
    R = 1.0

    tests = parse_setup()

    print_header()

    for test in tests:

        N = test[1]
        M = test[2]
        p0 = -10
        v0 = 1
        model = Instrumenter(DoubleInt(Q, R, p0, v0))
        rmse = numpy.empty((iterations,))
        enees = numpy.empty((iterations,))

        for it in xrange(iterations):
            T = 50
            numpy.random.seed(it)
            (x, y) = generate_data(T, Q, R, p0, v0)

            sim = Simulator(model, None, y)

            sim.simulate(N, M, filter='PF', smoother=test[0], smoother_options=test[3], meas_first=True)

            est_smooth_mean = sim.get_smoothed_mean()
#            est_smooth = sim.get_smoothed_estimates()
#            plt.figure()
#
#            plt.plot(xrange(T + 1), x[:, 0], 'r-', linewidth=2.0, label='True')
#            plt.plot(xrange(T + 1), x[:, 1], 'b-', linewidth=2.0, label='True')
#            plt.plot(xrange(T + 1), y, 'rx', linewidth=2.0, label='True')
#
#            plt.plot(xrange(T + 1), est_smooth_mean[:, 1], 'r--', linewidth=2.0, label='Smoother mean')
#            plt.plot(xrange(T + 1), est_smooth_mean[:, 0], 'b--', linewidth=2.0, label='Smoother mean')
#
#            for j in xrange(M):
##                pos = numpy.roll(numpy.cumsum(sim.straj.traj[:, j, 0]), 1, 0)
##                pos[0] = 0.0
##                pos += p0
#                plt.plot(xrange(T + 1), est_smooth[:, j, 1], 'r--', linewidth=1.0)
#                plt.plot(xrange(T + 1), est_smooth[:, j, 0], 'b--', linewidth=1.0)
#
#            plt.show()

            err = est_smooth_mean[:, (1, 0)] - x

            rmse[it] = numpy.sqrt(numpy.mean(err ** 2))

        print_stats(test[0], N, M, test[3], numpy.mean(rmse),
                    numpy.std(rmse) / math.sqrt(iterations),
                    model.oc)
