'''
Created on Aug 21, 2014

@author: ajn
'''
import numpy
import math
from pyparticleest.simulator import Simulator
from pyparticleest.utils.intrument import Instrumenter as Instrumenter
from pyparticleest.utils.intrument import OpCount as OpCount
from pscomp.models import DegenerateDoubleInt as DoubleInt
from pscomp.common import print_header
from pscomp.common import print_stats
from pscomp.common import generate_doubleint_data as generate_data
#import matplotlib.pyplot as plt






if __name__ == '__main__':

    iterations = 2000

    Q = 1.0
    R = 1.0

    print_header()

    N = 50
    M = 10
    p0 = -10
    v0 = 1
    model = DoubleInt(Q, R, p0, v0)


    Rvec = numpy.asarray([1, 2, 3, 4, 5, 10, 25, 50, 100, 200, 300, 400, 500])
    Rlen = len(Rvec)

    rmse = numpy.empty((Rlen, iterations))
    OpCounts = numpy.empty(Rlen, dtype=object)
    for i in xrange(len(OpCounts)):
        OpCounts[i] = OpCount()

    for it in xrange(iterations):
        T = 50
        numpy.random.seed(it)
        (x, y) = generate_data(T, Q, R, p0, v0)

        instrument = Instrumenter(model)
        sim = Simulator(instrument, None, y)

        sim.simulate(N, M, filter='PF', smoother='ancestor', meas_first=True)

        for r in xrange(1, Rvec[-1] + 1):
            sim.straj.traj = sim.model.pre_mhips_pass(sim.straj)
            sim.straj.traj = sim.straj.perform_mhips_pass(None, reduced=True)
            sim.straj.traj = sim.model.post_smoothing(sim.straj)

            if ((Rvec == r).any()):
                ind = numpy.where(Rvec == r)[0]
                OpCounts[ind] += instrument.oc
                smean = sim.get_smoothed_mean()
                err = smean[:, (0, 1)] - x
                rmse[ind, it] = numpy.sqrt(numpy.mean(err ** 2))

    for ind in xrange(Rlen):
        print_stats("mhips", N, M, {'R': Rvec[ind]}, numpy.mean(rmse[ind]),
                    numpy.std(rmse[ind]) / math.sqrt(iterations),
                    OpCounts[ind])
