'''
Created on Aug 21, 2014

@author: ajn
'''
import numpy
import math
from pyparticleest.simulator import Simulator
from pyparticleest.utils.intrument import Instrumenter as Instrumenter
from pyparticleest.utils.intrument import OpCount as OpCount
from pscomp.models import StdNonlin as StdNonLin
from pscomp.common import print_header
from pscomp.common import print_stats
import scipy.io
#import matplotlib.pyplot as plt






if __name__ == '__main__':

    data = scipy.io.loadmat("data/standard_nonlin_dataset.mat")
    iterations = len(data['x'])

    num = 50

    P0 = 5.0 * numpy.eye(1)
    Q = 10.0 * numpy.eye(1)
    R = 1.0 * numpy.eye(1)

    print_header()

    model = StdNonLin(P0, Q, R)

    Rvec = numpy.asarray([1, 2, 3, 4, 5, 10, 25, 50, 100, 200]) #, 300, 400, 500, 2000])
    Rlen = len(Rvec)

    rmse = numpy.empty((Rlen, iterations))
    OpCounts = numpy.empty(Rlen, dtype=object)
    for i in xrange(len(OpCounts)):
        OpCounts[i] = OpCount()
#    plt.ion()
#    plt.figure(1)
#    plt.show()
    for it in xrange(iterations):
        x = data['x'][it].reshape((-1, 1))
        y = data['y'][it].reshape((-1, 1))
        T = len(y)

        instrument = Instrumenter(model)
        sim = Simulator(instrument, None, y)

        sim.simulate(num, 1, filter='pf', smoother='ancestor', meas_first=True)
        ctraj = numpy.copy(sim.straj.traj)
        smean = sim.get_smoothed_mean()
        N = 1.0
        for r in xrange(1, Rvec[-1] + 1):

            sim.simulate(num, 1, filter='cpfas', filter_options={'cond_traj': ctraj},
                         smoother='ancestor', meas_first=True)


            ctraj = numpy.copy(sim.straj.traj)
            N = N + 1.0
            ratio = 1 / N
            smean = (1 - ratio) * smean + ratio * sim.get_smoothed_mean()

            if ((Rvec == r).any()):
                ind = numpy.where(Rvec == r)[0]
                OpCounts[ind] += instrument.oc
                err = smean - x
                rmse[ind, it] = numpy.sqrt(numpy.mean(err ** 2))
#                plt.clf()
#                plt.plot(numpy.arange(T), x, 'r')
#                plt.plot(numpy.arange(T), smean, 'b--')
#                plt.draw()

    for ind in xrange(Rlen):
        print_stats("pgas", num, 1, {'R': Rvec[ind]}, numpy.mean(rmse[ind]),
                    numpy.std(rmse[ind]) / math.sqrt(iterations),
                    OpCounts[ind])
