'''
Created on Aug 21, 2014

@author: ajn
'''
import numpy
import scipy.io
from pyparticleest.simulator import Simulator
from pyparticleest.utils.intrument import Instrumenter as Instrumenter
from pscomp.models import StdNonlin as StdNonLin
from pscomp.common import parse_setup
from pscomp.common import print_header
from pscomp.common import print_stats
import math


if __name__ == '__main__':


    data = scipy.io.loadmat("data/standard_nonlin_dataset.mat")
    iterations = len(data['x'])

    P0 = 5.0 * numpy.eye(1)
    Q = 10.0 * numpy.eye(1)
    R = 1.0 * numpy.eye(1)

    tests = parse_setup()

    print_header()

    for test in tests:

        N = test[1]
        M = test[2]

        model = Instrumenter(StdNonLin(P0, Q, R))

        rmse = numpy.empty((iterations))
        enees = numpy.empty((iterations))

        for it in xrange(iterations):

            x = data['x'][it].reshape((-1, 1))
            y = data['y'][it].reshape((-1, 1))
            T = len(y)

            sim = Simulator(model, None, y)
            sim.simulate(N, M, filter='PF', smoother=test[0], smoother_options=test[3], meas_first=True)

            est_mean = sim.get_smoothed_mean()

            err = est_mean - x
            rmse[it] = numpy.sqrt(numpy.mean(err ** 2))


        print_stats(test[0], N, M, test[3], numpy.mean(rmse),
                    numpy.std(rmse) / math.sqrt(iterations),
                    model.oc)
